summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJory A. Pratt <anarchy@gentoo.org>2013-09-10 08:41:18 -0500
committerJory A. Pratt <anarchy@gentoo.org>2013-09-10 08:41:18 -0500
commitd71c5fc82653297af5b7bd401a425febd58761a7 (patch)
tree9247a4435efaeff7b1421e39fe7b9ecdefa0517f
parentAdd pch useflag to sandbox-2.6 for hardened support (diff)
downloadanarchy-d71c5fc82653297af5b7bd401a425febd58761a7.tar.gz
anarchy-d71c5fc82653297af5b7bd401a425febd58761a7.tar.bz2
anarchy-d71c5fc82653297af5b7bd401a425febd58761a7.zip
Add cp/mv xattr support until sorted upstream. Fixes breakage introduced
in packages like grub/java who pax-mark in src_compile rather then src_install
-rw-r--r--sys-apps/coreutils/Manifest5
-rw-r--r--sys-apps/coreutils/coreutils-8.21.ebuild182
-rw-r--r--sys-apps/coreutils/files/coreutils-8.21-xattr-support.patch70
3 files changed, 257 insertions, 0 deletions
diff --git a/sys-apps/coreutils/Manifest b/sys-apps/coreutils/Manifest
new file mode 100644
index 0000000..86fe84b
--- /dev/null
+++ b/sys-apps/coreutils/Manifest
@@ -0,0 +1,5 @@
+AUX coreutils-8.21-xattr-support.patch 2101 SHA256 7e39f642ac71bb2bcb531c021a9af6daca9eda6c2a66060539ab20614cb3443f SHA512 b8273ea5371172ad88ed4bdb3423788de1b99d4a92d2a996fa2e0fb324c88fd7daaa2d749d1d972c10199d614bc898ce740c4ee8b6eb3e3dd867f11f7ecf3b8d WHIRLPOOL 3a187c117b6f4e852703c432036f0fb3c84cd43588d7ae128780a83d76d93e9be3c5dabd8266a6cdff2492a28e73324c8e142faf5c9e09ac9070befcf5f5571d
+DIST coreutils-8.21-man.tar.xz 42464 SHA256 0ab87b22a715505051ffb6d94ff01fb45988ba353f0a7c248e7a1c9d79e69815 SHA512 846a995f4ddc2bd20a1a9970fc476db3d3f0f4584fbde981940b81f0c3f4065c0ced7cae71c8518bed9e880143ce734bc98bae5b84da8600e26c32b194176013 WHIRLPOOL a5c424b24223d26a90ddf9b03839fb4311e4e89a408ff982d7b493ea3962dd88e305ecd08c799b554dfe74c19eb37f1f97307a94a4f7c79c84ae8b5f5bd26b12
+DIST coreutils-8.21-patches-1.0.tar.xz 6480 SHA256 3a10abca6e41e654837583b582a831c220a02ad9a6dc2bec66e60f7038a2f632 SHA512 4f19712c2c50cbe3f3abd1c48decd063df250d72344c02796f24a43eac9d6f543be64cb7f48e3716e92db964d93b8cfc08e860f7f79726ccada796fefbe7ddd8 WHIRLPOOL 72fb7908728ffc33d9f6bd360e1bc0d990573c01c2974de5ed842ba15224e9ad137ec24d727659748350886b53ee6da71f3773cf6a5c36bd091919090200294a
+DIST coreutils-8.21.tar.xz 5357988 SHA256 adaa44bdab3fa5eb352e80d8a31fdbf957b78653d0c2cd30d63e161444288e18 SHA512 cf0e5a393b486dd7fd46600dc2928bd2303250f3bce7b2f0de1bb3bf7b0cc3f6e29001b23fda5bbabe7686bf78917cfabe1f81abb602ab41cd406b45021fd229 WHIRLPOOL 4aa93529fc41f52841d82169fc5d8b10095462d24b46a97bff78c1abda865af5cb248cfbb67495c2618b338dd05e33fecf68a677c9ca268abf97eb5d0f1f05ef
+EBUILD coreutils-8.21.ebuild 6067 SHA256 4384281c8e531069472c07814fba78836d1b0e369f56d87a5a10f8f7249fb086 SHA512 cad77d770ccd691d026b8a9ad9a6cbf0d07509ef8b65cf9fae6ead40f93077ef46464d52fb766d06919ee4f8bb5b77347e5d664fcb4ed34c43a81b4d8be29d55 WHIRLPOOL 8405f03e89879d9762839a283882833422d57e17e5179792712b6d9d92ec58239550152bc120000c4a637c6919ed40bcc6e50986ee0fcac9478e5f47789ec05e
diff --git a/sys-apps/coreutils/coreutils-8.21.ebuild b/sys-apps/coreutils/coreutils-8.21.ebuild
new file mode 100644
index 0000000..78e07e1
--- /dev/null
+++ b/sys-apps/coreutils/coreutils-8.21.ebuild
@@ -0,0 +1,182 @@
+# Copyright 1999-2013 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-apps/coreutils/coreutils-8.21.ebuild,v 1.3 2013/04/28 01:07:58 vapier Exp $
+
+EAPI="3"
+
+inherit eutils flag-o-matic toolchain-funcs
+
+PATCH_VER="1.0"
+DESCRIPTION="Standard GNU file utilities (chmod, cp, dd, dir, ls...), text utilities (sort, tr, head, wc..), and shell utilities (whoami, who,...)"
+HOMEPAGE="http://www.gnu.org/software/coreutils/"
+SRC_URI="mirror://gnu-alpha/coreutils/${P}.tar.xz
+ mirror://gnu/${PN}/${P}.tar.xz
+ mirror://gentoo/${P}.tar.xz
+ mirror://gentoo/${P}-patches-${PATCH_VER}.tar.xz
+ http://dev.gentoo.org/~vapier/dist/${P}-patches-${PATCH_VER}.tar.xz
+ mirror://gentoo/${P}-man.tar.xz
+ http://dev.gentoo.org/~vapier/dist/${P}-man.tar.xz"
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~amd64-fbsd ~arm-linux ~x86-linux"
+IUSE="acl caps gmp nls selinux static userland_BSD vanilla xattr"
+
+LIB_DEPEND="acl? ( sys-apps/acl[static-libs] )
+ caps? ( sys-libs/libcap )
+ gmp? ( dev-libs/gmp[static-libs] )
+ xattr? ( !userland_BSD? ( sys-apps/attr[static-libs] ) )"
+RDEPEND="!static? ( ${LIB_DEPEND//\[static-libs]} )
+ selinux? ( sys-libs/libselinux )
+ nls? ( virtual/libintl )
+ !app-misc/realpath
+ !<sys-apps/util-linux-2.13
+ !sys-apps/stat
+ !net-mail/base64
+ !sys-apps/mktemp
+ !<app-forensics/tct-1.18-r1
+ !<net-fs/netatalk-2.0.3-r4
+ !<sci-chemistry/ccp4-6.1.1"
+DEPEND="${RDEPEND}
+ static? ( ${LIB_DEPEND} )
+ app-arch/xz-utils"
+
+src_prepare() {
+ if ! use vanilla ; then
+ use_if_iuse unicode || rm -f "${WORKDIR}"/patch/000_all_coreutils-i18n.patch
+ EPATCH_SUFFIX="patch" \
+ PATCHDIR="${WORKDIR}/patch" \
+ EPATCH_EXCLUDE="001_all_coreutils-gen-progress-bar.patch" \
+ epatch
+
+ epatch "${FILESDIR}/${PN}-8.21-xattr-support.patch"
+ fi
+
+ # Since we've patched many .c files, the make process will try to
+ # re-build the manpages by running `./bin --help`. When doing a
+ # cross-compile, we can't do that since 'bin' isn't a native bin.
+ # Also, it's not like we changed the usage on any of these things,
+ # so let's just update the timestamps and skip the help2man step.
+ set -- man/*.x
+ touch ${@/%x/1}
+
+ # Avoid perl dep for compiled in dircolors default #348642
+ if ! has_version dev-lang/perl ; then
+ touch src/dircolors.h
+ touch ${@/%x/1}
+ fi
+}
+
+src_configure() {
+ local myconf=''
+ if tc-is-cross-compiler && [[ ${CHOST} == *linux* ]] ; then
+ export fu_cv_sys_stat_statfs2_bsize=yes #311569
+ export gl_cv_func_realpath_works=yes #416629
+ fi
+
+ export gl_cv_func_mknod_works=yes #409919
+ use static && append-ldflags -static && sed -i '/elf_sys=yes/s:yes:no:' configure #321821
+ use selinux || export ac_cv_{header_selinux_{context,flash,selinux}_h,search_setfilecon}=no #301782
+ use userland_BSD && myconf="${myconf} -program-prefix=g --program-transform-name=s/stat/nustat/"
+ # kill/uptime - procps
+ # groups/su - shadow
+ # hostname - net-tools
+ econf \
+ --with-packager="Gentoo" \
+ --with-packager-version="${PVR} (p${PATCH_VER:-0})" \
+ --with-packager-bug-reports="http://bugs.gentoo.org/" \
+ --enable-install-program="arch" \
+ --enable-no-install-program="groups,hostname,kill,su,uptime" \
+ --enable-largefile \
+ $(use caps || echo --disable-libcap) \
+ $(use_enable nls) \
+ $(use_enable acl) \
+ $(use_enable xattr) \
+ $(use_with gmp) \
+ ${myconf}
+}
+
+src_test() {
+ # Non-root tests will fail if the full path isnt
+ # accessible to non-root users
+ chmod -R go-w "${WORKDIR}"
+ chmod a+rx "${WORKDIR}"
+
+ # coreutils tests like to do `mount` and such with temp dirs
+ # so make sure /etc/mtab is writable #265725
+ # make sure /dev/loop* can be mounted #269758
+ mkdir -p "${T}"/mount-wrappers
+ mkwrap() {
+ local w ww
+ for w in "$@" ; do
+ ww="${T}/mount-wrappers/${w}"
+ cat <<-EOF > "${ww}"
+ #!${EPREFIX}/bin/sh
+ exec env SANDBOX_WRITE="\${SANDBOX_WRITE}:/etc/mtab:/dev/loop" $(type -P $w) "\$@"
+ EOF
+ chmod a+rx "${ww}"
+ done
+ }
+ mkwrap mount umount
+
+ addwrite /dev/full
+ #export RUN_EXPENSIVE_TESTS="yes"
+ #export FETISH_GROUPS="portage wheel"
+ env PATH="${T}/mount-wrappers:${PATH}" \
+ emake -j1 -k check || die "make check failed"
+}
+
+src_install() {
+ emake install DESTDIR="${D}" || die
+ dodoc AUTHORS ChangeLog* NEWS README* THANKS TODO
+
+ insinto /etc
+ newins src/dircolors.hin DIR_COLORS || die
+
+ if [[ ${USERLAND} == "GNU" ]] ; then
+ cd "${ED}"/usr/bin
+ dodir /bin
+ # move critical binaries into /bin (required by FHS)
+ local fhs="cat chgrp chmod chown cp date dd df echo false ln ls
+ mkdir mknod mv pwd rm rmdir stty sync true uname"
+ mv ${fhs} ../../bin/ || die "could not move fhs bins"
+ # move critical binaries into /bin (common scripts)
+ local com="basename chroot cut dir dirname du env expr head mkfifo
+ mktemp readlink seq sleep sort tail touch tr tty vdir wc yes"
+ mv ${com} ../../bin/ || die "could not move common bins"
+ # create a symlink for uname in /usr/bin/ since autotools require it
+ local x
+ for x in ${com} uname ; do
+ dosym /bin/${x} /usr/bin/${x} || die
+ done
+ else
+ # For now, drop the man pages, collides with the ones of the system.
+ rm -rf "${ED}"/usr/share/man
+ fi
+
+}
+
+pkg_postinst() {
+ ewarn "Make sure you run 'hash -r' in your active shells."
+ ewarn "You should also re-source your shell settings for LS_COLORS"
+ ewarn " changes, such as: source /etc/profile"
+
+ # /bin/dircolors sometimes sticks around #224823
+ if [ -e "${EROOT}/usr/bin/dircolors" ] && [ -e "${EROOT}/bin/dircolors" ] ; then
+ if strings "${EROOT}/bin/dircolors" | grep -qs "GNU coreutils" ; then
+ einfo "Deleting orphaned GNU /bin/dircolors for you"
+ rm -f "${EROOT}/bin/dircolors"
+ fi
+ fi
+
+ # Help out users using experimental filesystems
+ if grep -qs btrfs "${EROOT}"/etc/fstab /proc/mounts ; then
+ case $(uname -r) in
+ 2.6.[12][0-9]|2.6.3[0-7]*)
+ ewarn "You are running a system with a buggy btrfs driver."
+ ewarn "Please upgrade your kernel to avoid silent corruption."
+ ewarn "See: https://bugs.gentoo.org/353907"
+ ;;
+ esac
+ fi
+}
diff --git a/sys-apps/coreutils/files/coreutils-8.21-xattr-support.patch b/sys-apps/coreutils/files/coreutils-8.21-xattr-support.patch
new file mode 100644
index 0000000..99c2e30
--- /dev/null
+++ b/sys-apps/coreutils/files/coreutils-8.21-xattr-support.patch
@@ -0,0 +1,70 @@
+From: Anthony G. Basile <blueness@gentoo.org>
+
+Preserve extended attributes by default when doing cp, mv or
+install when built with --enable-xattr.
+
+diff --git a/src/cp.c b/src/cp.c
+index e235b32..2bab87f 100644
+--- a/src/cp.c
++++ b/src/cp.c
+@@ -784,9 +784,14 @@ cp_option_init (struct cp_options *x)
+ x->explicit_no_preserve_mode = false;
+ x->preserve_security_context = false;
+ x->require_preserve_context = false;
++#if USE_XATTR
++ x->preserve_xattr = true;
++ x->require_preserve_xattr = true;
++#else
+ x->preserve_xattr = false;
+- x->reduce_diagnostics = false;
+ x->require_preserve_xattr = false;
++#endif
++ x->reduce_diagnostics = false;
+
+ x->data_copy_required = true;
+ x->require_preserve = false;
+diff --git a/src/install.c b/src/install.c
+index a5ed7a8..03bdac3 100644
+--- a/src/install.c
++++ b/src/install.c
+@@ -280,7 +280,13 @@ cp_option_init (struct cp_options *x)
+ x->data_copy_required = true;
+ x->require_preserve = false;
+ x->require_preserve_context = false;
++#if USE_XATTR
++ x->preserve_xattr = true;
++ x->require_preserve_xattr = true;
++#else
++ x->preserve_xattr = false;
+ x->require_preserve_xattr = false;
++#endif
+ x->recursive = false;
+ x->sparse_mode = SPARSE_AUTO;
+ x->symbolic_link = false;
+@@ -296,7 +302,6 @@ cp_option_init (struct cp_options *x)
+ x->open_dangling_dest_symlink = false;
+ x->update = false;
+ x->preserve_security_context = false;
+- x->preserve_xattr = false;
+ x->verbose = false;
+ x->dest_info = NULL;
+ x->src_info = NULL;
+diff --git a/src/mv.c b/src/mv.c
+index 1cfcd82..b9aec6e 100644
+--- a/src/mv.c
++++ b/src/mv.c
+@@ -124,8 +124,13 @@ cp_option_init (struct cp_options *x)
+ x->data_copy_required = true;
+ x->require_preserve = false; /* FIXME: maybe make this an option */
+ x->require_preserve_context = false;
++#if USE_XATTR
+ x->preserve_xattr = true;
++ x->require_preserve_xattr = true;
++#else
++ x->preserve_xattr = false;
+ x->require_preserve_xattr = false;
++#endif
+ x->recursive = true;
+ x->sparse_mode = SPARSE_AUTO; /* FIXME: maybe make this an option */
+ x->symbolic_link = false;
+